using System;
using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;

public partial class ReadExcel : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void Export(object sender, EventArgs e)
    {
        DataSet ds = ImportExcel(Server.MapPath("~/Book1.xls"));
        //DataSet ds = ImportExcel2007(Server.MapPath("~/Book1.xlsx"));
        List<string> id = new List<string>();
        List<string> name = new List<string>();
        List<string> country = new List<string>();

        int idIndex = 0;
        int nameIndex = 0;
        int countryIndex = 0;

        for (int i = 0; i < ds.Tables[0].Columns.Count; i++)
        {
            if (ds.Tables[0].Rows[0][i].ToString().ToUpper() == "ID")
            {
                idIndex = i;
            }
            else if (ds.Tables[0].Rows[0][i].ToString().ToUpper() == "NAME")
            {
                nameIndex = i;
            }
            else if (ds.Tables[0].Rows[0][i].ToString().ToUpper() == "COUNTRY")
            {
                countryIndex = i;
            }
        }

        for (int i = 1; i < ds.Tables[0].Rows.Count; i++)
        {
            id.Add(ds.Tables[0].Rows[i][idIndex].ToString());
            name.Add(ds.Tables[0].Rows[i][nameIndex].ToString());
            country.Add(ds.Tables[0].Rows[i][countryIndex].ToString());
        }
    }
    //Read To Excel 97-2003 File
    private DataSet ImportExcel(String strFilePath)
    {
        String strExcelConn = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" + strFilePath + "; Extended Properties='Excel 8.0;IMEX=1;HDR=No'";
        OleDbConnection connExcel = new OleDbConnection(strExcelConn);
        OleDbCommand cmdExcel = new OleDbCommand();
        try
        {
            cmdExcel.Connection = connExcel;

            //Check if the Sheet Exists
            connExcel.Open();
            DataTable dtExcelSchema;
            //Get the Schema of the WorkBook
            dtExcelSchema = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null);
            connExcel.Close();

            //Read Data from Sheet1
            connExcel.Open();
            OleDbDataAdapter da = new OleDbDataAdapter();
            DataSet ds = new DataSet();
            string SheetName = dtExcelSchema.Rows[0]["TABLE_NAME"].ToString();
            cmdExcel.CommandText = "SELECT * From [" + SheetName + "]";
            //Range Query
            //cmdExcel.CommandText = "SELECT * From [" + SheetName + "A3:B5]";

            da.SelectCommand = cmdExcel;
            da.Fill(ds);
            connExcel.Close();
            return ds;
        }
        catch
        {
            return null;
        }
        finally
        {
            cmdExcel.Dispose();
            connExcel.Dispose();
        }
    }
    //Read To Excel 97-2007 File
    private DataSet ImportExcel2007(String strFilePath)
    {
        String strExcelConn = "Provider=Microsoft.ACE.OLEDB.12.0; Data Source=" + strFilePath + "; Extended Properties='Excel 8.0;IMEX=1;HDR=No'";
        OleDbConnection connExcel = new OleDbConnection(strExcelConn);
        OleDbCommand cmdExcel = new OleDbCommand();
        try
        {
            cmdExcel.Connection = connExcel;

            //Check if the Sheet Exists
            connExcel.Open();
            DataTable dtExcelSchema;
            //Get the Schema of the WorkBook
            dtExcelSchema = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, null);
            connExcel.Close();

            //Read Data from Sheet1
            connExcel.Open();
            OleDbDataAdapter da = new OleDbDataAdapter();
            DataSet ds = new DataSet();
            string SheetName = dtExcelSchema.Rows[0]["TABLE_NAME"].ToString();
            cmdExcel.CommandText = "SELECT * From [" + SheetName + "]";

            //Range Query
            //cmdExcel.CommandText = "SELECT * From [" + SheetName + "A3:B5]";

            da.SelectCommand = cmdExcel;
            da.Fill(ds);
            connExcel.Close();
            return ds;
        }
        catch
        {
            return null;
        }
        finally
        {
            cmdExcel.Dispose();
            connExcel.Dispose();
        }
    }
}
