﻿Imports System.Data.OleDb
Imports System.Data

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Export(ByVal sender As Object, ByVal e As EventArgs)
        Dim ds As DataSet = ImportExcel(Server.MapPath("~/Book1.xls"))
        Dim id As List(Of String) = New List(Of String)()
        Dim name As List(Of String) = New List(Of String)()
        Dim country As List(Of String) = New List(Of String)()
        Dim idIndex As Integer = 0
        Dim nameIndex As Integer = 0
        Dim countryIndex As Integer = 0
        For i As Integer = 0 To ds.Tables(0).Columns.Count - 1
            If ds.Tables(0).Rows(0)(i).ToString().ToUpper() = "ID" Then
                idIndex = i
            ElseIf ds.Tables(0).Rows(0)(i).ToString().ToUpper() = "NAME" Then
                nameIndex = i
            ElseIf ds.Tables(0).Rows(0)(i).ToString().ToUpper() = "COUNTRY" Then
                countryIndex = i
            End If
        Next

        For i As Integer = 1 To ds.Tables(0).Rows.Count - 1
            id.Add(ds.Tables(0).Rows(i)(idIndex).ToString())
            name.Add(ds.Tables(0).Rows(i)(nameIndex).ToString())
            country.Add(ds.Tables(0).Rows(i)(countryIndex).ToString())
        Next
    End Sub

    Private Function ImportExcel(ByVal strFilePath As String) As DataSet
        Dim strExcelConn As String = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & strFilePath & "; Extended Properties='Excel 8.0;IMEX=1;HDR=No'"
        Dim connExcel As OleDbConnection = New OleDbConnection(strExcelConn)
        Dim cmdExcel As OleDbCommand = New OleDbCommand()
        Try
            cmdExcel.Connection = connExcel
            connExcel.Open()
            Dim dtExcelSchema As DataTable
            dtExcelSchema = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, Nothing)
            connExcel.Close()
            connExcel.Open()
            Dim da As OleDbDataAdapter = New OleDbDataAdapter()
            Dim ds As DataSet = New DataSet()
            Dim SheetName As String = dtExcelSchema.Rows(0)("TABLE_NAME").ToString()
            cmdExcel.CommandText = "SELECT * From [" & SheetName & "]"
            da.SelectCommand = cmdExcel
            da.Fill(ds)
            connExcel.Close()
            Return ds
        Catch
            Return Nothing
        Finally
            cmdExcel.Dispose()
            connExcel.Dispose()
        End Try
    End Function

    Private Function ImportExcel2007(ByVal strFilePath As String) As DataSet
        Dim strExcelConn As String = "Provider=Microsoft.ACE.OLEDB.12.0; Data Source=" & strFilePath & "; Extended Properties='Excel 8.0;IMEX=1;HDR=No'"
        Dim connExcel As OleDbConnection = New OleDbConnection(strExcelConn)
        Dim cmdExcel As OleDbCommand = New OleDbCommand()
        Try
            cmdExcel.Connection = connExcel
            connExcel.Open()
            Dim dtExcelSchema As DataTable
            dtExcelSchema = connExcel.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, Nothing)
            connExcel.Close()
            connExcel.Open()
            Dim da As OleDbDataAdapter = New OleDbDataAdapter()
            Dim ds As DataSet = New DataSet()
            Dim SheetName As String = dtExcelSchema.Rows(0)("TABLE_NAME").ToString()
            cmdExcel.CommandText = "SELECT * From [" & SheetName & "]"
            da.SelectCommand = cmdExcel
            da.Fill(ds)
            connExcel.Close()
            Return ds
        Catch
            Return Nothing
        Finally
            cmdExcel.Dispose()
            connExcel.Dispose()
        End Try
    End Function
End Class